/*
 * File: app/view/MainNav.js
 *
 * This file was generated by Sencha Architect version 2.0.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Sencha Touch 2.0.x library, under independent license.
 * License of Sencha Architect does not include license for Sencha Touch 2.0.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('CCIVIC.view.MainNav', {
    extend: 'Ext.navigation.View',
    alias: 'widget.mainNav',

    config: {
        defaultBackButtonText: 'Tornar',
        layout: {
            animation: false,
            type: 'card'
        },
        navigationBar: {
            hidden: true,
            itemId: 'NavBar'
        },
        items: [
            {
                xtype: 'nestedlist',
                id: 'temesList',
                itemId: 'temesList',
                backText: 'Tornar',
                displayField: 'nom',
                store: 'temesTreeStore',
                title: 'Tipus incidència',
                useTitleAsBackText: false,
                toolbar: {
                    xtype: 'toolbar',
                    docked: 'top',
                    itemId: 'temesToolbar',
                    items: [
                        {
                            xtype: 'button',
                            docked: 'right',
                            itemId: 'btnDades',
                            ui: 'round',
                            iconCls: 'settings',
                            iconMask: true
                        }
                    ]
                }
            }
        ],
        listeners: [
            {
                fn: 'onTemesListLeafItemTap',
                event: 'leafitemtap',
                delegate: '#temesList'
            },
            {
                fn: 'onBtnDadesTap',
                event: 'tap',
                delegate: '#btnDades'
            },
            {
                fn: 'onTemesListShow',
                event: 'show',
                delegate: '#temesList'
            },
            {
                fn: 'onNavigationviewShow',
                event: 'show'
            }
        ]
    },

    onTemesListLeafItemTap: function(nestedlist, list, index, target, record, e, options) {
        var cmp = Ext.getCmp('Incidencia');
        var Panel;

        if (cmp){
            Ext.getCmp('Incidencia').destroy();
        }

        Panel = Ext.create('CCIVIC.view.Incidencia',{title:'Dades Incidència',fullscreen: true});

        //Es modifica el titol amb el leaf seleccionat.
        Ext.ComponentQuery.query('#descIncid')[0].setTitle('Descripció '+record.get('nom'));
        Ext.ComponentQuery.query('#temaHidden')[0].setValue(record.get('nom'));
        Ext.ComponentQuery.query('#NavBar')[0].setHidden(false);

        this.push(Panel);

    },

    onBtnDadesTap: function(button, e, options) {
        var Panel= Ext.create('CCIVIC.view.Dades',{fullscreen: true});
        this.push(Panel);
    },

    onTemesListShow: function(component, options) {
        Ext.ComponentQuery.query('#NavBar')[0].setHidden(true);
    },

    onNavigationviewShow: function(component, options) {
        var storeIncid = Ext.data.StoreManager.lookup('IncidStore');

        Ext.ComponentQuery.query('#NavBar')[0].setHidden(true);

        if (storeIncid.getCount() === 0){
            storeIncid.add(
            {IdCamp:'LOC', CodiCamp: 'Localització', ValorCamp: '', ValorCamp1: '',ValorCamp2: '',ValorImg:'', Req: '*'},
            {IdCamp:'OBS', CodiCamp: 'Observacions', ValorCamp: '', ValorCamp1: '',ValorCamp2: '',ValorImg:'', Req: ''},
            {IdCamp:'RISC', CodiCamp: 'Comporta risc', ValorCamp: '', ValorCamp1: '',ValorCamp2: '',ValorImg:'', Req: ''},
            {IdCamp:'FOTO', CodiCamp: 'Fotografia', ValorCamp: '', ValorCamp1: '',ValorCamp2: '',ValorImg:'', Req:''}
            );    
        }

        var storePref = Ext.data.StoreManager.lookup('PrefStore');

        if (storePref.getCount() === 0){    
            Ext.Msg.show({ title: 'Avís:',
                message: 'És necessari introduir les dades personals.',
                buttons:  [{text : 'Acceptar'}]});

                storePref.add(
                {IdPref:'NOM', CodiPref: 'Nom', ValorPref: '', Req: '*'},
                {IdPref:'COGNOM', CodiPref: 'Cognoms', ValorPref: '', Req: '*'},
                {IdPref:'NUMDOC', CodiPref: 'Número de document', ValorPref: '', Req: '*'},
                {IdPref:'TEL', CodiPref: 'Mòbil', ValorPref: '', Req:''},
                {IdPref:'EMAIL', CodiPref: 'Adreça electrònica', ValorPref: '', Req: '*'});

                var Panel= Ext.create('CCIVIC.view.Dades',{fullscreen: true});
                this.push(Panel);
            }
    }

});